/*
Copyright (c) 2003 Forward Computing and Control Pty. Ltd.
NSW. Australia,  www.forward.com.au
All rights reserved.

Redistribution of the source of this package, with or without
modification, is NOT permitted.

Redistribution of the compiled java .class files of this package, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions in compiled java .class form must reproduce the above
   copyright notice, this list of conditions and the following disclaimer
   in the documentation and/or other materials provided with the distribution.

2. If the software is modified, the compiled java .class distribution must
   include, in the documentation and/or other materials provided with the 
   distribution, a statement that the software has been modified and
   identify the person who was responsible for the modifications.  

3. Neither the name of the author nor Forward Computing and Control may be 
   used to endorse or promote products derived from this software
   without specific prior written permission.

4.  All advertising materials mentioning features or use of this
    software must display the following acknowledgment: 
    "This product includes software developed by Matthew Ford
     and Forward Computing and Control Pty. Ltd. 
    (http://www.forward.com.au)."


THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package au.com.forward.runWST.misc;
import au.com.forward.runWST.maps.*;
import java.util.*;
import java.util.logging.*;

	/** Wrap an entry in a map so that name appears as the root and the value
	 *  appears as the child or children.
	 */
	public class AttributeMapEntry implements IAttributeTreeNode {
		protected Object key, value;
		
		public AttributeMapEntry(Object key, Object value) {
			this.key = key;
			this.value = value;
		}
		
		public int getChildCount(Object parent) {
			return AttributeTreeNode.getAttributeTreeNode(value).getChildCount(value);
		}

		
		public int getIndexOfChild(Object parent, Object child) {
			return AttributeTreeNode.getAttributeTreeNode(value).getIndexOfChild(value, child);
		}
    
		
		public Object getChild(Object parent, int index) {
			return AttributeTreeNode.getAttributeTreeNode(value).getChild(value, index);
		}

		public boolean isLeaf(Object node) {
			return false;
		}

		
		public String toString() {
			String keyStr = key.toString();
			if (keyStr.length() > AttributeTreeView.MAX_LINE_LENGTH) {
				keyStr = keyStr.substring(0,AttributeTreeView.MAX_LINE_LENGTH)+".....";
			}
			return "<HTML><B>"+keyStr;
		}
	}

