/*
Copyright (c) 2003 Forward Computing and Control Pty. Ltd.
NSW. Australia,  www.forward.com.au
All rights reserved.

Redistribution of the source of this package, with or without
modification, is NOT permitted.

Redistribution of the compiled java .class files of this package, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions in compiled java .class form must reproduce the above
   copyright notice, this list of conditions and the following disclaimer
   in the documentation and/or other materials provided with the distribution.

2. If the software is modified, the compiled java .class distribution must
   include, in the documentation and/or other materials provided with the 
   distribution, a statement that the software has been modified and
   identify the person who was responsible for the modifications.  

3. Neither the name of the author nor Forward Computing and Control may be 
   used to endorse or promote products derived from this software
   without specific prior written permission.

4.  All advertising materials mentioning features or use of this
    software must display the following acknowledgment: 
    "This product includes software developed by Matthew Ford
     and Forward Computing and Control Pty. Ltd. 
    (http://www.forward.com.au)."


THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package au.com.forward.runWST.misc;
import org.antlr.stringtemplate.StringTemplate;
import au.com.forward.webstringtemplate.filters.IWSTFilter;

	/**
	 *  Description of the Class
	 *
	 *@author     matthew ford
	 *@created    November 27, 2003
	 */
	public class AttributeTreeNode implements IAttributeTreeNode {
		Object value = null;
		
		public AttributeTreeNode(Object obj) {
			value = obj;
			if (value == null) {
				value = "";
			}
		}
		
		/**
		 *
		 *@param  parent  Description of the Parameter
		 *@return         The childCount value
		 */
		public int getChildCount(Object parent) {
			return 1;
		}


		/**
		 *
		 *@param  parent  Description of the Parameter
		 *@param  child   Description of the Parameter
		 *@return         The indexOfChild value
		 */
		public int getIndexOfChild(Object parent, Object child) {
			return 0;
		}
    

		/**
		 *
		 *@param  parent  Description of the Parameter
		 *@param  index   Description of the Parameter
		 *@return         The child value
		 */
		public Object getChild(Object parent, int index) {
			IWSTFilter filter = null;
			while (value instanceof IWSTFilter) {
				filter = (IWSTFilter)value;
				value = filter.getObject();
			}
			if (value instanceof String) {
				String valueStr = ""+value;
				if (valueStr.length() > AttributeTreeView.MAX_LINE_LENGTH) {
					valueStr = valueStr.substring(0,AttributeTreeView.MAX_LINE_LENGTH)+".....";
				}
				return valueStr;
			} // else	
			return value;
		}	



		/**
		 *  Gets the leaf attribute of the Wrapper object
		 *
		 *@param  node  Description of the Parameter
		 *@return       The leaf value
		 */
		public boolean isLeaf(Object node) {
			return true;
		}
		
		public String toString() {
			String valueStr = ""+value;
			if (valueStr.length() > AttributeTreeView.MAX_LINE_LENGTH) {
				valueStr = valueStr.substring(0,AttributeTreeView.MAX_LINE_LENGTH)+".....";
			}
			return valueStr;
		}

	/** Get a wrapper object by adding "Wrapper" to class name.
	 *  If not present, return the object.
	 */
	public static IAttributeTreeNode getAttributeTreeNode(Object o) {
		IWSTFilter filter = null;
		while (o instanceof IWSTFilter) {
			filter = (IWSTFilter)o;
			o = filter.getObject();
		}
		if (o instanceof IAttributeTreeNode) {
			return (IAttributeTreeNode)o;
		} 
		return new AttributeTreeNode(o);
	}
		
	}


