/*
Copyright (c) 2003 Forward Computing and Control Pty. Ltd.
NSW. Australia,  www.forward.com.au
All rights reserved.

Redistribution of the source of this package, with or without
modification, is NOT permitted.

Redistribution of the compiled java .class files of this package, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions in compiled java .class form must reproduce the above
   copyright notice, this list of conditions and the following disclaimer
   in the documentation and/or other materials provided with the distribution.

2. If the software is modified, the compiled java .class distribution must
   include, in the documentation and/or other materials provided with the 
   distribution, a statement that the software has been modified and
   identify the person who was responsible for the modifications.  

3. Neither the name of the author nor Forward Computing and Control may be 
   used to endorse or promote products derived from this software
   without specific prior written permission.

4.  All advertising materials mentioning features or use of this
    software must display the following acknowledgment: 
    "This product includes software developed by Matthew Ford
     and Forward Computing and Control Pty. Ltd. 
    (http://www.forward.com.au)."


THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package au.com.forward.runWST.misc;

import org.antlr.stringtemplate.*;
import au.com.forward.runWST.maps.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.tree.*;
import java.util.*;

/** This class visually illustrates a map of Attributes
 *
 *  <pre>
 *  Map attributes = ;
 *  AttributeTreeView viz =
 *  		new AttributeTreeView("attributes",attributes);
 *  viz.setVisible(true);
 * </Pre>
 */
public class AttributeTreeView extends JFrame {
    // The initial width and height of the frame
    static final int WIDTH = 600;
    static final int HEIGHT = 500;

		/**
		 * Limit of display lines, 250 (plus "...." if necessary).
		 */
		public static final int MAX_LINE_LENGTH = 250;
		
    public AttributeTreeView() {
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                Frame f = (Frame)e.getSource();
                f.setVisible(false);
                f.dispose();
                // System.exit(0);
            }
        });
				
        setSize(WIDTH, HEIGHT);
    }
		
		public void updateAttributes(String label, AttributeHashtable st) {
			  setTitle(label);
        if (st == null) {
					st = new AttributeHashtable();
					st.put("Attribute map is null","");
				}
        JTreeAttributePanel tp =
				new JTreeAttributePanel(new JTreeAttributeModel(st,label), null);
				//Create a panel and add components to it.
				JPanel contentPane = new JPanel(new BorderLayout());
				contentPane.add(tp, BorderLayout.CENTER);

				//Make it the content pane.
				contentPane.setOpaque(true);
				setContentPane(contentPane);
				((JComponent)getContentPane()).revalidate();
				repaint();
    }			

}
