// $ANTLR 2.7.2: "html.g" -> "HTMLParser.java"$

/*
Copyright (c) 2003 Forward Computing and Control Pty. Ltd.
NSW. Australia,  www.forward.com.au
All rights reserved.

Redistribution of the source of this package, with or without
modification, is NOT permitted.

Redistribution of the compiled java .class files of this package, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions in compiled java .class form must reproduce the above
   copyright notice, this list of conditions and the following disclaimer
   in the documentation and/or other materials provided with the distribution.

2. If the software is modified, the compiled java .class distribution must
   include, in the documentation and/or other materials provided with the 
   distribution, a statement that the software has been modified and
   identify the person who was responsible for the modifications.  

3. Neither the name of the author nor Forward Computing and Control may be 
   used to endorse or promote products derived from this software
   without specific prior written permission.

4.  All advertising materials mentioning features or use of this
    software must display the following acknowledgment: 
    "This product includes software developed by Matthew Ford
     and Forward Computing and Control Pty. Ltd. 
    (http://www.forward.com.au)."


THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

package au.com.forward.runWST.wstAttributeReader.language;
import au.com.forward.runWST.wstAttributeReader.*;
import org.antlr.stringtemplate.*;

import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;

public class HTMLParser extends antlr.LLkParser       implements HTMLTokenTypes
 {

  HtmlMapState mapState = null;
	
  StringTemplateErrorListener listener = null;
	
	public void setMapState(HtmlMapState mapState) {
   if (mapState == null) {
    throw new IllegalStateException("HtmlMapState cannot be null.");
	 }
		this.mapState = mapState;
		this.listener = mapState.getErrorListener();
	}
	
	
  public void reportError(RecognitionException e) {
    listener.error("line:"+e.getLine()+" col:"+e.getColumn()+" "+e.getMessage(),null);
  }

	

protected HTMLParser(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
}

public HTMLParser(TokenBuffer tokenBuf) {
  this(tokenBuf,1);
}

protected HTMLParser(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
}

public HTMLParser(TokenStream lexer) {
  this(lexer,1);
}

public HTMLParser(ParserSharedInputState state) {
  super(state,1);
  tokenNames = _tokenNames;
}

	public final void document() throws RecognitionException, TokenStreamException {
		
		
		if (mapState == null){
		throw new IllegalStateException("Need to set HtmlMapState for this parser.");
			 }
		if (listener == null){
		throw new IllegalStateException("Need to set StringTemplateErrorListener for this parser.");
			 }
		
		
		try {      // for error handling
			{
			_loop3:
			do {
				if ((LA(1)==PCDATA)) {
					pcdata();
				}
				else {
					break _loop3;
				}
				
			} while (true);
			}
			{
			switch ( LA(1)) {
			case OULIST:
			case OOLIST:
			case ODLIST:
			{
				body();
				break;
			}
			case EOF:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			mapState.endBody(null);
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_0);
		}
	}
	
	public final void pcdata() throws RecognitionException, TokenStreamException {
		
		Token  pc = null;
		
		try {      // for error handling
			pc = LT(1);
			match(PCDATA);
			mapState.pcdata(pc.getText());
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_1);
		}
	}
	
	public final void body() throws RecognitionException, TokenStreamException {
		
		
		try {      // for error handling
			{
			int _cnt7=0;
			_loop7:
			do {
				if ((LA(1)==OULIST||LA(1)==OOLIST||LA(1)==ODLIST)) {
					body_content();
				}
				else {
					if ( _cnt7>=1 ) { break _loop7; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt7++;
			} while (true);
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_0);
		}
	}
	
	public final void body_content() throws RecognitionException, TokenStreamException {
		
		
		try {      // for error handling
			list();
			{
			_loop10:
			do {
				if ((LA(1)==PCDATA)) {
					pcdata();
				}
				else {
					break _loop10;
				}
				
			} while (true);
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_2);
		}
	}
	
	public final void list() throws RecognitionException, TokenStreamException {
		
		
		try {      // for error handling
			switch ( LA(1)) {
			case OULIST:
			{
				unordered_list();
				break;
			}
			case OOLIST:
			{
				ordered_list();
				break;
			}
			case ODLIST:
			{
				def_list();
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_3);
		}
	}
	
	public final void unordered_list() throws RecognitionException, TokenStreamException {
		
		Token  ou = null;
		Token  cu = null;
		
		try {      // for error handling
			ou = LT(1);
			match(OULIST);
			mapState.startUL(ou);
			{
			_loop15:
			do {
				if ((LA(1)==PCDATA)) {
					pcdata();
				}
				else {
					break _loop15;
				}
				
			} while (true);
			}
			{
			int _cnt17=0;
			_loop17:
			do {
				if ((LA(1)==OLITEM)) {
					list_item();
				}
				else {
					if ( _cnt17>=1 ) { break _loop17; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt17++;
			} while (true);
			}
			cu = LT(1);
			match(CULIST);
			mapState.endUL(cu);
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_3);
		}
	}
	
	public final void ordered_list() throws RecognitionException, TokenStreamException {
		
		Token  oo = null;
		Token  co = null;
		
		try {      // for error handling
			oo = LT(1);
			match(OOLIST);
			mapState.startOL(oo);
			{
			_loop20:
			do {
				if ((LA(1)==PCDATA)) {
					pcdata();
				}
				else {
					break _loop20;
				}
				
			} while (true);
			}
			{
			int _cnt22=0;
			_loop22:
			do {
				if ((LA(1)==OLITEM)) {
					list_item();
				}
				else {
					if ( _cnt22>=1 ) { break _loop22; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt22++;
			} while (true);
			}
			co = LT(1);
			match(COLIST);
			mapState.endOL(co);
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_3);
		}
	}
	
	public final void def_list() throws RecognitionException, TokenStreamException {
		
		Token  od = null;
		Token  cd = null;
		
		try {      // for error handling
			od = LT(1);
			match(ODLIST);
			mapState.startDL(od);
			{
			_loop25:
			do {
				if ((LA(1)==PCDATA)) {
					pcdata();
				}
				else {
					break _loop25;
				}
				
			} while (true);
			}
			{
			int _cnt27=0;
			_loop27:
			do {
				if ((LA(1)==ODTERM)) {
					def_list_item();
				}
				else {
					if ( _cnt27>=1 ) { break _loop27; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt27++;
			} while (true);
			}
			cd = LT(1);
			match(CDLIST);
			mapState.endDL(cd);
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_3);
		}
	}
	
	public final void list_item() throws RecognitionException, TokenStreamException {
		
		Token  ol = null;
		Token  cl = null;
		
		try {      // for error handling
			ol = LT(1);
			match(OLITEM);
			mapState.startLI(ol);
			{
			_loop30:
			do {
				switch ( LA(1)) {
				case PCDATA:
				{
					pcdata();
					break;
				}
				case OULIST:
				case OOLIST:
				case ODLIST:
				{
					list();
					break;
				}
				default:
				{
					break _loop30;
				}
				}
			} while (true);
			}
			{
			switch ( LA(1)) {
			case CLITEM:
			{
				cl = LT(1);
				match(CLITEM);
				{
				_loop33:
				do {
					if ((LA(1)==PCDATA)) {
						pcdata();
					}
					else {
						break _loop33;
					}
					
				} while (true);
				}
				break;
			}
			case CULIST:
			case COLIST:
			case OLITEM:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_4);
		}
	}
	
	public final void def_list_item() throws RecognitionException, TokenStreamException {
		
		
		try {      // for error handling
			dt();
			dd();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_5);
		}
	}
	
	public final void dt() throws RecognitionException, TokenStreamException {
		
		Token  od = null;
		Token  cd = null;
		
		try {      // for error handling
			od = LT(1);
			match(ODTERM);
			mapState.startDT(od);
			{
			int _cnt37=0;
			_loop37:
			do {
				if ((LA(1)==PCDATA)) {
					pcdata();
				}
				else {
					if ( _cnt37>=1 ) { break _loop37; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt37++;
			} while (true);
			}
			{
			switch ( LA(1)) {
			case CDTERM:
			{
				cd = LT(1);
				match(CDTERM);
				{
				_loop40:
				do {
					if ((LA(1)==PCDATA)) {
						pcdata();
					}
					else {
						break _loop40;
					}
					
				} while (true);
				}
				break;
			}
			case ODDEF:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_6);
		}
	}
	
	public final void dd() throws RecognitionException, TokenStreamException {
		
		Token  od = null;
		
		try {      // for error handling
			od = LT(1);
			match(ODDEF);
			mapState.startDD(od);
			{
			_loop43:
			do {
				switch ( LA(1)) {
				case PCDATA:
				{
					pcdata();
					break;
				}
				case OULIST:
				case OOLIST:
				case ODLIST:
				{
					list();
					break;
				}
				default:
				{
					break _loop43;
				}
				}
			} while (true);
			}
			{
			switch ( LA(1)) {
			case CDDEF:
			{
				match(CDDEF);
				{
				_loop46:
				do {
					if ((LA(1)==PCDATA)) {
						pcdata();
					}
					else {
						break _loop46;
					}
					
				} while (true);
				}
				break;
			}
			case CDLIST:
			case ODTERM:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_5);
		}
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"text",
		"<UL>",
		"</UL>",
		"<OL>",
		"</OL>",
		"<DL>",
		"</DL>",
		"<LI>",
		"</LI>",
		"<DT>",
		"</DT>",
		"<DD>",
		"</DD>",
		"TAG",
		"OTHER_TAG",
		"WST_COMMENT_DATA",
		"WST_COMMENT",
		"<WST>",
		"</WST>",
		"COMMENT_DATA",
		"COMMENT",
		"WS",
		"ATTR",
		"WORD",
		"STRING",
		"WSCHARS",
		"SPECIAL",
		"HEXNUM",
		"INT",
		"HEXINT",
		"DIGIT",
		"HEXDIGIT",
		"LCLETTER",
		"UNDEFINED_TOKEN"
	};
	
	private static final long[] mk_tokenSet_0() {
		long[] data = { 2L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
	private static final long[] mk_tokenSet_1() {
		long[] data = { 131058L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_1 = new BitSet(mk_tokenSet_1());
	private static final long[] mk_tokenSet_2() {
		long[] data = { 674L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_2 = new BitSet(mk_tokenSet_2());
	private static final long[] mk_tokenSet_3() {
		long[] data = { 81906L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_3 = new BitSet(mk_tokenSet_3());
	private static final long[] mk_tokenSet_4() {
		long[] data = { 2368L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_4 = new BitSet(mk_tokenSet_4());
	private static final long[] mk_tokenSet_5() {
		long[] data = { 9216L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_5 = new BitSet(mk_tokenSet_5());
	private static final long[] mk_tokenSet_6() {
		long[] data = { 32768L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_6 = new BitSet(mk_tokenSet_6());
	
	}
